(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: zonation.mli,v 1.58 2014-01-21 17:17:24 fclement Exp $ *)

open Segmentation_types;;

(*val digest : ('a, 'b, ('a, 'b) zonation) Utype_digest.lifter2;;*)

val gimage_of_zonation : ('a, 'b) zonation -> 'a gimage;;

val make_trivial_zonation :
  ('b -> zone_number -> 'a zc_gimage -> 'a best_zone_cutting) ->
  ('a gimage -> 'a) -> ('a gimage -> 'a gimage -> 'a cost) ->
  (('a, 'b) pimage -> 'a cost) ->
  'a gimage -> component_number -> component_number list ->
  ('a, 'b) zonation
;;

val cuttings_from_family :
  bounds -> Umatrix_nonempty_set.t -> Unatural.t ->
  basic_cutting_family -> Umatrix_nonempty_set.dichotomy list
;;

val better_cutting :
  'a best_component_cutting -> zone_number -> 'a zone ->
  'a best_component_cutting
;;

val same : ('a, 'b) zonation -> ('a, 'b) zonation -> bool;;

val indicator_of_zcc : 'a zone_cutting_candidate -> 'a indicator;;
val indicator_of_ccc : 'a component_cutting_candidate -> 'a indicator;;
val indicator_of_gcc : 'a global_cutting_candidate -> 'a indicator;;

val bzc_of :
  'a indicator -> Umatrix_nonempty_set.dichotomy -> 'a best_zone_cutting
;;

val bcc_of :
  zone_number -> 'a zone_cutting_candidate -> 'a best_component_cutting
;;

val bgc_of :
  component_number -> 'a component_cutting_candidate -> 'a best_global_cutting
;;
