(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_uindex pp_a ppf = function
  | a_u_i -> Uuniverse_print.print_index pp_a ppf a_u_i
;;

let print_index pp_a ppf = function
  | a_u_u -> print_uindex (print_uindex pp_a) ppf a_u_u
;;

let print_t pp_a ppf = function
  | { Unonempty_set.universe = a_u_t; Unonempty_set.uindices = a_u_u_t; } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Format.fprintf ppf "%,@[<1>universe =@ ";
    Uuniverse_print.print_t pp_a ppf a_u_t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>uindices =@ ";
    Uuniverse_print.print_t (print_uindex pp_a) ppf a_u_u_t;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_nonempty_subset pp_a ppf = function
  | {
      Unonempty_set.support = a_t;
      Unonempty_set.indices = a_i_a;
      Unonempty_set.nonempty_set = a_t0;
    } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>support =@ ";
    print_t pp_a ppf a_t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>indices =@ ";
    Lib_print.print_Array (print_index pp_a) ppf a_i_a;
    Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>nonempty_set =@ "; print_t pp_a ppf a_t0;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_dichotomy pp_a ppf = function
  | (a_n, a_n0) ->
    Format.fprintf ppf "%,@[<1>(@,"; print_nonempty_subset pp_a ppf a_n;
    Format.fprintf ppf "%,,@ "; print_nonempty_subset pp_a ppf a_n0;
    Format.fprintf ppf "%,@,)@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
